Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 82)
@@ -1,4 +1,11 @@
 #ifndef morpheo_behavioural_Allocation_h
 #define morpheo_behavioural_Allocation_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
 
 #include "Common/include/Debug.h"
@@ -46,9 +53,18 @@
     {									\
       sig = interface->set_signal_in <type> (name, size);		\
-    }									
+    }									\
+  else									\
+    {									\
+      log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface->get_name().c_str(),name); \
+    }
+  
 #define ALLOC_SIGNAL_OUT( sig, name, type, size)			\
   if (size > 0)								\
     {									\
       sig = interface->set_signal_out<type> (name, size);		\
+    }									\
+  else									\
+    {									\
+      log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface->get_name().c_str(),name); \
     }
 
@@ -63,8 +79,14 @@
 
 #define INSTANCE_SC_SIGNAL(component, sig)	\
-  (*(component->sig)) (*(sig));
-
-#define DELETE_SC_SIGNAL( sig)						\
-  delete sig;
+  {						\
+    TEST_PTR(component->sig);			\
+    TEST_PTR(sig);				\
+    (*(component->sig)) (*(sig));		\
+  }
+
+#define DELETE_SC_SIGNAL( sig)			\
+  {						\
+    delete sig;					\
+  }
 
 // ----------------------------------------------------------------------
@@ -166,4 +188,8 @@
 	    sig [alloc_signal_it1] = interface[alloc_signal_it1]->set_signal_in <type> (name, size); \
 	  }								\
+	else								\
+	  {								\
+	    log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface[alloc_signal_it1]->get_name().c_str(),name); \
+	  }								\
       }									\
   }
@@ -177,4 +203,8 @@
 	  {								\
 	    sig [alloc_signal_it1] = interface[alloc_signal_it1]->set_signal_out<type> (name, size); \
+	  }								\
+	else								\
+	  {								\
+	    log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface[alloc_signal_it1]->get_name().c_str(),name); \
 	  }								\
       }									\
@@ -208,4 +238,6 @@
   for (uint32_t alloc_signal_it1=0; alloc_signal_it1<it1; alloc_signal_it1++) \
     {									\
+      TEST_PTR(component->sig [alloc_signal_it1]);			\
+      TEST_PTR(sig            [alloc_signal_it1]);			\
       (*(component->sig[alloc_signal_it1])) (*(sig[alloc_signal_it1]));	\
     }
@@ -330,4 +362,8 @@
 		sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_in <type> (name, size); \
 	      }								\
+	    else							\
+	      {								\
+		log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface[alloc_signal_it1][alloc_signal_it2]->get_name().c_str(),name); \
+	      }								\
 	  }								\
       }									\
@@ -345,4 +381,8 @@
 	      {								\
 		sig [alloc_signal_it1][alloc_signal_it2] = interface[alloc_signal_it1][alloc_signal_it2]->set_signal_out <type> (name, size); \
+	      }								\
+	    else							\
+	      {								\
+		log_printf(INFO,true,FUNCTION,_("%s %s.%s.%s : size is nul."),MSG_INFORMATION,_component->get_name().c_str(),interface[alloc_signal_it1][alloc_signal_it2]->get_name().c_str(),name); \
 	      }								\
 	  }								\
@@ -393,4 +433,6 @@
     for (uint32_t alloc_signal_it2=0; alloc_signal_it2<it2; alloc_signal_it2++)	\
       {									\
+	TEST_PTR(component->sig [alloc_signal_it1][alloc_signal_it2]);	\
+	TEST_PTR(sig            [alloc_signal_it1][alloc_signal_it2]);	\
 	(*(component->sig[alloc_signal_it1][alloc_signal_it2])) (*(sig[alloc_signal_it1][alloc_signal_it2])); \
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Component.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Component.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Component.h	(revision 82)
@@ -5,5 +5,5 @@
  * $Id$
  *
- * [ Description ]
+ * [ Description ]
  * 
  */
@@ -65,22 +65,24 @@
 #define INSTANCE_ALL          0x7
 
-  typedef struct
-  {
-//public : Component * _component;
-  public : Entity    * _entity   ;
-  public : Tinstance_t _instance ;
-  } Tcomponent_t;    
-  
   class Component
   {
-    // -----[ fields ]----------------------------------------------------
+    typedef struct
+    {
+    public : Component * _component;
+    public : Entity    * _entity   ;
+    public : Tinstance_t _instance ;
+    } Tcomponent_t;    
+  
+    // -----[ fields ]----------------------------------------------------
   private   : const Tusage_t             _usage;
   private   : Entity                   * _entity        ;
   private   : std::list<Tcomponent_t*> * _list_component;
 
-    // -----[ methods ]---------------------------------------------------
-  public    :                       Component         (Tusage_t usage=USE_ALL);
+    // -----[ methods ]---------------------------------------------------
+  public    :                       Component         (Tusage_t usage);
   public    :                       Component         (const Component & component);
   public    :                       ~Component        ();
+
+  public    : std::string           get_name          (void);
 
   public    : Entity *              set_entity        (std::string        name   
@@ -124,4 +126,7 @@
   private   : bool                  test_map          (uint32_t depth, bool recursive);
 
+//   public    : bool                  test_equi         (bool recursive=true);
+//   private   : bool                  test_equi         (uint32_t depth, bool recursive);
+
 #ifdef POSITION
   public    : void                  interface_map     (std::string component_src ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Debug_component.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Debug_component.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Debug_component.h	(revision 82)
@@ -43,9 +43,10 @@
 #  define         DEBUG_Decod_unit                                  false
 #  define           DEBUG_Decod                                     false
+#  define           DEBUG_Decod_queue                               true
 #  define         DEBUG_Ifetch_unit                                 false
 #  define           DEBUG_Address_management                        false
 #  define           DEBUG_Ifetch_queue                              false
 #  define           DEBUG_Ifetch_unit_Glue                          false
-#  define         DEBUG_Prediction_unit                             false
+#  define         DEBUG_Prediction_unit                             true 
 #  define           DEBUG_Branch_Target_Buffer                      false
 #  define             DEBUG_Branch_Target_Buffer_Glue               false
@@ -55,10 +56,10 @@
 #  define             DEBUG_Meta_Predictor                          false
 #  define               DEBUG_Meta_Predictor_Glue                   false
-#  define                 DEBUG_Two_Level_Branch_Predictor          false
-#  define                   DEBUG_Two_Level_Branch_Predictor_Glue   false 
-#  define                   DEBUG_Branch_History_Table              false
-#  define                   DEBUG_Pattern_History_Table             false
-#  define           DEBUG_Prediction_unit_Glue                      true 
-#  define           DEBUG_Return_Address_Stack                      true
+#  define               DEBUG_Two_Level_Branch_Predictor            false
+#  define                 DEBUG_Two_Level_Branch_Predictor_Glue     false 
+#  define                 DEBUG_Branch_History_Table                false
+#  define                 DEBUG_Pattern_History_Table               false
+#  define           DEBUG_Prediction_unit_Glue                      false 
+#  define           DEBUG_Return_Address_Stack                      false
 #  define           DEBUG_Update_Prediction_Table                   true
 #  define     DEBUG_Multi_OOO_Engine                                false
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Entity.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Entity.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Entity.h	(revision 82)
@@ -26,6 +26,6 @@
   {
     // -----[ fields ]----------------------------------------------------
-  private   : const std::string          _name         ;
-  private   : const std::string          _type         ;
+  private   : const std::string     _name         ;
+  private   : const std::string     _type         ;
 #ifdef POSITION
   private   : const schema_t        _schema       ;
@@ -36,5 +36,5 @@
 
 #ifdef POSITION
-  private   : std::string                _comment      ;
+  private   : std::string           _comment      ;
 
   private   :       bool            _is_map       ;
@@ -51,18 +51,18 @@
 						       ,schema_t      schema 
 #endif
-							,Tusage_t       usage=USE_ALL
+							,Tusage_t       usage
 							);
   public    :                        Entity           (const Entity & entity);
   public    :                       ~Entity           ();
 
-  public    : std::string                get_name          (void);
-  public    : std::string                get_type          (void);
+  public    : std::string           get_name          (void);
+  public    : std::string           get_type          (void);
 
 #ifdef POSITION
   public    : void                  set_comment       (std::string comment);
-  private   : std::string                get_comment       (void          );
+  private   : std::string           get_comment       (void          );
 #endif
   public    : Interfaces *          set_interfaces    (void);
-  private   : std::string                get_interfaces    (void);
+  private   : std::string           get_interfaces    (void);
   public    : Interfaces *          get_interfaces_list(void);
 
@@ -78,5 +78,6 @@
 #endif
 
-  public    : bool                  test_map          (uint32_t depth,bool top_level);
+  public    : bool                  test_map          (uint32_t depth,bool top_level, bool is_behavioural);
+//   public    : bool                  test_equi         (uint32_t depth);
 
 #ifdef POSITION
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface.h	(revision 82)
@@ -63,5 +63,5 @@
 							  ,localisation_t localisation
 #endif
-							  ,Tusage_t       usage=USE_ALL
+							  ,Tusage_t       usage
 							  );
 
@@ -220,14 +220,15 @@
 							  std::string             counter_name  ,
 							  std::string             reset_name    );
-  public    : std::string                testbench_test       (Vhdl           * & vhdl        ,
+  public    : std::string           testbench_test       (Vhdl           * & vhdl        ,
 							  std::string             counter_name,
 							  std::string             reset_name);
-  public    : std::string                testbench_test_ok    (Vhdl           * & vhdl        );
-  protected : std::string                testbench_test_name   (Vhdl           * & vhdl);
-  protected : std::string                testbench_test_ok_name(Vhdl           * & vhdl);
-  protected : std::string                testbench_test_transaction_name(Vhdl           * & vhdl);
-#endif
-
-  public    : bool                  test_map             (uint32_t depth, bool top_level);
+  public    : std::string           testbench_test_ok    (Vhdl           * & vhdl        );
+  protected : std::string           testbench_test_name   (Vhdl           * & vhdl);
+  protected : std::string           testbench_test_ok_name(Vhdl           * & vhdl);
+  protected : std::string           testbench_test_transaction_name(Vhdl           * & vhdl);
+#endif
+
+  public    : bool                  test_map             (uint32_t depth, bool top_level, bool is_behavioural);
+//   public    : bool                  test_equi            (uint32_t depth);
 
 #ifdef POSITION
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface_fifo.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface_fifo.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface_fifo.h	(revision 82)
@@ -45,5 +45,5 @@
 							  ,localisation_t localisation
 #endif
-							  ,Tusage_t       usage=USE_ALL
+							  ,Tusage_t       usage
 							  );
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interfaces.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interfaces.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interfaces.h	(revision 82)
@@ -33,5 +33,5 @@
     // -----[ methods ]---------------------------------------------------
   public    :                       Interfaces            (std::string name, 
-							   Tusage_t usage=USE_ALL);
+							   Tusage_t usage);
   public    :                       Interfaces            (const Interfaces & interfaces);
   public    :                       ~Interfaces           ();
@@ -80,5 +80,6 @@
 #endif
 
-  public    : bool                  test_map              (uint32_t depth, bool top_level);
+  public    : bool                  test_map              (uint32_t depth, bool top_level, bool is_behavioural);
+//   public    : bool                  test_equi             (uint32_t depth);
 
   public    : friend std::ostream&       operator<<            (std::ostream& output_stream,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Parameters.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Parameters.h	(revision 82)
@@ -44,7 +44,7 @@
 
   public    : bool        have_error  (void)            { return (_error.length() != 0);};
-  public    : void        error       (std::string str) { _error       += "[   ERROR   ] <" + _component + "> " + str + "\n";}
-  public    : void        warning     (std::string str) { _warning     += "[  WARNING  ] <" + _component + "> " + str + "\n";}
-  public    : void        information (std::string str) { _information += "[INFORMATION] <" + _component + "> " + str + "\n";}
+  public    : void        error       (std::string str) { _error       += MSG_ERROR      ; _error       += " <" + _component + "> " + str + "\n";}
+  public    : void        warning     (std::string str) { _warning     += MSG_WARNING    ; _warning     += " <" + _component + "> " + str + "\n";}
+  public    : void        information (std::string str) { _information += MSG_INFORMATION; _information += " <" + _component + "> " + str + "\n";}
   public    : std::string print       (void)            { return _error + _warning + _information;};
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h	(revision 82)
@@ -79,5 +79,5 @@
   public    :                   ~Signal         ();
 
-  public    : std::string            get_name                (void);
+  public    : std::string       get_name                (void);
   public    : uint32_t          get_size                (void);
   public    : void              set_size                (uint32_t size);
@@ -92,5 +92,6 @@
   public    : bool              presence_testbench      (void);
 
-  public    : bool              test_map                (uint32_t depth, bool top_level);
+  public    : bool              test_map                (uint32_t depth, bool top_level, bool is_behavioural);
+//   public    : bool              test_equi               (uint32_t depth);
 
   public    : void              link                    (Signal * signal_dest,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 82)
@@ -4,11 +4,9 @@
 #include "Common/include/ToString.h"
 
-// Identification : MORPHEO_MAJOR_VERSION.MORPHEO_MINOR_VERSION.MORPHEO_REVISION
-// Revision       : svn variable 
-
 #define MORPHEO_MAJOR_VERSION 0
 #define MORPHEO_MINOR_VERSION 2
-#define MORPHEO_REVISION      0
-//$Revision$
+#define MORPHEO_REVISION      82
+
+// Identification : MORPHEO_MAJOR_VERSION.MORPHEO_MINOR_VERSION.MORPHEO_REVISION
 
 #define MORPHEO_VERSION       morpheo::toString(MORPHEO_MAJOR_VERSION)+"."+morpheo::toString(MORPHEO_MINOR_VERSION)+"."+morpheo::toString(MORPHEO_REVISION)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h.sed
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h.sed	(revision 82)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h.sed	(revision 82)
@@ -0,0 +1,14 @@
+#ifndef morpheo_behavioural_Version_h
+#define morpheo_behavioural_Version_h
+
+#include "Common/include/ToString.h"
+
+#define MORPHEO_MAJOR_VERSION 0
+#define MORPHEO_MINOR_VERSION 2
+#define MORPHEO_REVISION      @REVISION
+
+// Identification : MORPHEO_MAJOR_VERSION.MORPHEO_MINOR_VERSION.MORPHEO_REVISION
+
+#define MORPHEO_VERSION       morpheo::toString(MORPHEO_MAJOR_VERSION)+"."+morpheo::toString(MORPHEO_MINOR_VERSION)+"."+morpheo::toString(MORPHEO_REVISION)
+
+#endif
